=== debian/changelog ===
freerdp (1.1.0~git20140921.1.440916e+dfsg1-7+alpha) unreleased; urgency=medium

  * Fix alignment of reference utf16 strings in test suite.
    Fixes FTBFS on Alpha (#800716)

 -- Michael Cree <mcree@orcon.net.nz>  Mon, 25 Apr 2016 22:49:57 +1200
